Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/openssl/OpenSSLEngine.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/openssl/OpenSSLEngine.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/openssl/OpenSSLEngine.java
@@ -16,6 +16,7 @@
  */
 package org.apache.tomcat.util.net.openssl;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.ReadOnlyBufferException;
 import java.security.Principal;
@@ -40,7 +41,7 @@ import javax.net.ssl.SSLSessionContext;
 
 import org.apache.juli.logging.Log;
 import org.apache.juli.logging.LogFactory;
-import org.apache.tomcat.jni.Buffer;
+// import org.apache.tomcat.jni.Buffer;
 import org.apache.tomcat.jni.Pool;
 import org.apache.tomcat.jni.SSL;
 import org.apache.tomcat.jni.SSLContext;
@@ -130,7 +131,7 @@ public final class OpenSSLEngine extends
 
     private static final String INVALID_CIPHER = "SSL_NULL_WITH_NULL_NULL";
 
-    private static final long EMPTY_ADDR = Buffer.address(ByteBuffer.allocate(0));
+    private static final long EMPTY_ADDR = org.apache.tomcat.jni.Buffer.address(ByteBuffer.allocate(0));
 
     // OpenSSL state
     private final long ssl;
@@ -242,10 +243,10 @@ public final class OpenSSLEngine extends
         final int sslWrote;
 
         if (src.isDirect()) {
-            final long addr = Buffer.address(src) + pos;
+            final long addr = org.apache.tomcat.jni.Buffer.address(src) + pos;
             sslWrote = SSL.writeToSSL(ssl, addr, len);
             if (sslWrote >= 0) {
-                src.position(pos + sslWrote);
+                ((Buffer)src).position(pos + sslWrote);
                 return sslWrote;
             }
         } else {
@@ -253,17 +254,17 @@ public final class OpenSSLEngine extends
             try {
                 final long addr = memoryAddress(buf);
 
-                src.limit(pos + len);
+                ((Buffer)src).limit(pos + len);
 
                 buf.put(src);
-                src.limit(limit);
+                ((Buffer)src).limit(limit);
 
                 sslWrote = SSL.writeToSSL(ssl, addr, len);
                 if (sslWrote >= 0) {
-                    src.position(pos + sslWrote);
+                    ((Buffer)src).position(pos + sslWrote);
                     return sslWrote;
                 } else {
-                    src.position(pos);
+                    ((Buffer)src).position(pos);
                 }
             } finally {
                 buf.clear();
@@ -282,10 +283,10 @@ public final class OpenSSLEngine extends
         final int pos = src.position();
         final int len = src.remaining();
         if (src.isDirect()) {
-            final long addr = Buffer.address(src) + pos;
+            final long addr = org.apache.tomcat.jni.Buffer.address(src) + pos;
             final int netWrote = SSL.writeToBIO(networkBIO, addr, len);
             if (netWrote >= 0) {
-                src.position(pos + netWrote);
+                ((Buffer)src).position(pos + netWrote);
                 return netWrote;
             }
         } else {
@@ -297,10 +298,10 @@ public final class OpenSSLEngine extends
 
                 final int netWrote = SSL.writeToBIO(networkBIO, addr, len);
                 if (netWrote >= 0) {
-                    src.position(pos + netWrote);
+                    ((Buffer)src).position(pos + netWrote);
                     return netWrote;
                 } else {
-                    src.position(pos);
+                    ((Buffer)src).position(pos);
                 }
             } finally {
                 buf.clear();
@@ -317,11 +318,11 @@ public final class OpenSSLEngine extends
     private static int readPlaintextData(final long ssl, final ByteBuffer dst) {
         if (dst.isDirect()) {
             final int pos = dst.position();
-            final long addr = Buffer.address(dst) + pos;
+            final long addr = org.apache.tomcat.jni.Buffer.address(dst) + pos;
             final int len = dst.limit() - pos;
             final int sslRead = SSL.readFromSSL(ssl, addr, len);
             if (sslRead > 0) {
-                dst.position(pos + sslRead);
+                ((Buffer)dst).position(pos + sslRead);
                 return sslRead;
             }
         } else {
@@ -335,9 +336,9 @@ public final class OpenSSLEngine extends
                 final int sslRead = SSL.readFromSSL(ssl, addr, len);
                 if (sslRead > 0) {
                     buf.limit(sslRead);
-                    dst.limit(pos + sslRead);
+                    ((Buffer)dst).limit(pos + sslRead);
                     dst.put(buf);
-                    dst.limit(limit);
+                    ((Buffer)dst).limit(limit);
                     return sslRead;
                 }
             } finally {
@@ -355,10 +356,10 @@ public final class OpenSSLEngine extends
     private static int readEncryptedData(final long networkBIO, final ByteBuffer dst, final int pending) {
         if (dst.isDirect() && dst.remaining() >= pending) {
             final int pos = dst.position();
-            final long addr = Buffer.address(dst) + pos;
+            final long addr = org.apache.tomcat.jni.Buffer.address(dst) + pos;
             final int bioRead = SSL.readFromBIO(networkBIO, addr, pending);
             if (bioRead > 0) {
-                dst.position(pos + bioRead);
+                ((Buffer)dst).position(pos + bioRead);
                 return bioRead;
             }
         } else {
@@ -370,9 +371,9 @@ public final class OpenSSLEngine extends
                 if (bioRead > 0) {
                     buf.limit(bioRead);
                     int oldLimit = dst.limit();
-                    dst.limit(dst.position() + bioRead);
+                    ((Buffer)dst).limit(dst.position() + bioRead);
                     dst.put(buf);
-                    dst.limit(oldLimit);
+                    ((Buffer)dst).limit(oldLimit);
                     return bioRead;
                 }
             } finally {
@@ -963,7 +964,7 @@ public final class OpenSSLEngine extends
 
 
     private static long memoryAddress(ByteBuffer buf) {
-        return Buffer.address(buf);
+        return org.apache.tomcat.jni.Buffer.address(buf);
     }
 
     private SSLEngineResult.Status getEngineStatus() {
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/SecureNio2Channel.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/SecureNio2Channel.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/SecureNio2Channel.java
@@ -18,6 +18,7 @@ package org.apache.tomcat.util.net;
 
 import java.io.EOFException;
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.AsynchronousSocketChannel;
 import java.nio.channels.CompletionHandler;
@@ -133,7 +134,7 @@ public class SecureNio2Channel extends N
         unwrapBeforeRead = true;
         closed = false;
         closing = false;
-        netInBuffer.clear();
+        ((Buffer)netInBuffer).clear();
     }
 
     @Override
@@ -323,7 +324,7 @@ public class SecureNio2Channel extends N
                     } else if (handshake.getStatus() == Status.BUFFER_UNDERFLOW) {
                         if (netInBuffer.position() == netInBuffer.limit()) {
                             //clear the buffer if we have emptied it out on data
-                            netInBuffer.clear();
+                            ((Buffer)netInBuffer).clear();
                         }
                         //read more data
                         if (async) {
@@ -418,9 +419,9 @@ public class SecureNio2Channel extends N
             clientRequestedCiphers = Collections.emptyList();
             break;
         case NON_SECURE:
-            netOutBuffer.clear();
+            ((Buffer)netOutBuffer).clear();
             netOutBuffer.put(TLSClientHelloExtractor.USE_TLS_RESPONSE);
-            netOutBuffer.flip();
+            ((Buffer)netOutBuffer).flip();
             flush();
             throw new IOException(sm.getString("channel.nio.ssl.foundHttp"));
         }
@@ -444,8 +445,8 @@ public class SecureNio2Channel extends N
         netOutBuffer = ByteBufferUtils.expand(netOutBuffer, sslEngine.getSession().getPacketBufferSize());
 
         // Set limit and position to expected values
-        netOutBuffer.position(0);
-        netOutBuffer.limit(0);
+        ((Buffer)netOutBuffer).position(0);
+        ((Buffer)netOutBuffer).limit(0);
 
         // Initiate handshake
         sslEngine.beginHandshake();
@@ -469,10 +470,10 @@ public class SecureNio2Channel extends N
         if (!getBufHandler().isReadBufferEmpty()) throw new IOException(sm.getString("channel.nio.ssl.appInputNotEmpty"));
         if (!getBufHandler().isWriteBufferEmpty()) throw new IOException(sm.getString("channel.nio.ssl.appOutputNotEmpty"));
 
-        netOutBuffer.position(0);
-        netOutBuffer.limit(0);
-        netInBuffer.position(0);
-        netInBuffer.limit(0);
+        ((Buffer)netOutBuffer).position(0);
+        ((Buffer)netOutBuffer).limit(0);
+        ((Buffer)netInBuffer).position(0);
+        ((Buffer)netInBuffer).limit(0);
         getBufHandler().reset();
 
         handshakeComplete = false;
@@ -521,12 +522,12 @@ public class SecureNio2Channel extends N
     protected SSLEngineResult handshakeWrap() throws IOException {
         //this should never be called with a network buffer that contains data
         //so we can clear it here.
-        netOutBuffer.clear();
+        ((Buffer)netOutBuffer).clear();
         //perform the wrap
         getBufHandler().configureWriteBufferForRead();
         SSLEngineResult result = sslEngine.wrap(getBufHandler().getWriteBuffer(), netOutBuffer);
         //prepare the results to be written
-        netOutBuffer.flip();
+        ((Buffer)netOutBuffer).flip();
         //set the status
         handshakeStatus = result.getHandshakeStatus();
         return result;
@@ -543,7 +544,7 @@ public class SecureNio2Channel extends N
         //loop while we can perform pure SSLEngine data
         do {
             //prepare the buffer with the incoming data
-            netInBuffer.flip();
+            ((Buffer)netInBuffer).flip();
             //call unwrap
             getBufHandler().configureReadBufferForWrite();
             result = sslEngine.unwrap(netInBuffer, getBufHandler().getReadBuffer());
@@ -601,7 +602,7 @@ public class SecureNio2Channel extends N
             throw new IOException(sm.getString("channel.nio.ssl.pendingWriteDuringClose"), e);
         }
         //prep the buffer for the close message
-        netOutBuffer.clear();
+        ((Buffer)netOutBuffer).clear();
         //perform the close, since we called sslEngine.closeOutbound
         SSLEngineResult handshake = sslEngine.wrap(getEmptyBuf(), netOutBuffer);
         //we should be in a close state
@@ -609,7 +610,7 @@ public class SecureNio2Channel extends N
             throw new IOException(sm.getString("channel.nio.ssl.invalidCloseState"));
         }
         //prepare the buffer for writing
-        netOutBuffer.flip();
+        ((Buffer)netOutBuffer).flip();
         //if there is data to be written
         try {
             if (timeout > 0) {
@@ -711,7 +712,7 @@ public class SecureNio2Channel extends N
             SSLEngineResult unwrap;
             do {
                 //prepare the buffer
-                netInBuffer.flip();
+                ((Buffer)netInBuffer).flip();
                 //unwrap the data
                 try {
                     unwrap = sslEngine.unwrap(netInBuffer, dst);
@@ -854,10 +855,10 @@ public class SecureNio2Channel extends N
         protected void wrap() {
             try {
                 if (!netOutBuffer.hasRemaining()) {
-                    netOutBuffer.clear();
+                    ((Buffer)netOutBuffer).clear();
                     SSLEngineResult result = sslEngine.wrap(src, netOutBuffer);
                     written = result.bytesConsumed();
-                    netOutBuffer.flip();
+                    ((Buffer)netOutBuffer).flip();
                     if (result.getStatus() == Status.OK) {
                         if (result.getHandshakeStatus() == HandshakeStatus.NEED_TASK)
                             tasks();
@@ -909,7 +910,7 @@ public class SecureNio2Channel extends N
                         SSLEngineResult unwrap;
                         do {
                             //prepare the buffer
-                            netInBuffer.flip();
+                            ((Buffer)netInBuffer).flip();
                             //unwrap the data
                             unwrap = sslEngine.unwrap(netInBuffer, dst2);
                             //compact the buffer
@@ -1017,7 +1018,7 @@ public class SecureNio2Channel extends N
                                 overflowState = OverflowState.DONE;
                             }
                             //prepare the buffer
-                            netInBuffer.flip();
+                            ((Buffer)netInBuffer).flip();
                             //unwrap the data
                             unwrap = sslEngine.unwrap(netInBuffer, dsts2, offset, length2);
                             //compact the buffer
@@ -1137,11 +1138,11 @@ public class SecureNio2Channel extends N
         }
         try {
             // Prepare the output buffer
-            netOutBuffer.clear();
+            ((Buffer)netOutBuffer).clear();
             // Wrap the source data into the internal buffer
             SSLEngineResult result = sslEngine.wrap(src, netOutBuffer);
             final int written = result.bytesConsumed();
-            netOutBuffer.flip();
+            ((Buffer)netOutBuffer).flip();
             if (result.getStatus() == Status.OK) {
                 if (result.getHandshakeStatus() == HandshakeStatus.NEED_TASK) {
                     tasks();
@@ -1191,11 +1192,11 @@ public class SecureNio2Channel extends N
         }
         try {
              // Prepare the output buffer
-            netOutBuffer.clear();
+            ((Buffer)netOutBuffer).clear();
             // Wrap the source data into the internal buffer
             SSLEngineResult result = sslEngine.wrap(srcs, offset, length, netOutBuffer);
             final int written = result.bytesConsumed();
-            netOutBuffer.flip();
+            ((Buffer)netOutBuffer).flip();
             if (result.getStatus() == Status.OK) {
                 if (result.getHandshakeStatus() == HandshakeStatus.NEED_TASK) {
                     tasks();
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/SecureNioChannel.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/SecureNioChannel.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/SecureNioChannel.java
@@ -19,6 +19,7 @@ package org.apache.tomcat.util.net;
 import java.io.EOFException;
 import java.io.IOException;
 import java.net.SocketTimeoutException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.SelectionKey;
 import java.nio.channels.Selector;
@@ -95,7 +96,7 @@ public class SecureNioChannel extends Ni
         handshakeComplete = false;
         closed = false;
         closing = false;
-        netInBuffer.clear();
+        ((Buffer)netInBuffer).clear();
     }
 
     @Override
@@ -315,9 +316,9 @@ public class SecureNioChannel extends Ni
             clientRequestedCiphers = Collections.emptyList();
             break;
         case NON_SECURE:
-            netOutBuffer.clear();
+            ((Buffer)netOutBuffer).clear();
             netOutBuffer.put(TLSClientHelloExtractor.USE_TLS_RESPONSE);
-            netOutBuffer.flip();
+            ((Buffer)netOutBuffer).flip();
             flushOutbound();
             throw new IOException(sm.getString("channel.nio.ssl.foundHttp"));
         }
@@ -341,8 +342,8 @@ public class SecureNioChannel extends Ni
         netOutBuffer = ByteBufferUtils.expand(netOutBuffer, sslEngine.getSession().getPacketBufferSize());
 
         // Set limit and position to expected values
-        netOutBuffer.position(0);
-        netOutBuffer.limit(0);
+        ((Buffer)netOutBuffer).position(0);
+        ((Buffer)netOutBuffer).limit(0);
 
         // Initiate handshake
         sslEngine.beginHandshake();
@@ -454,12 +455,12 @@ public class SecureNioChannel extends Ni
     protected SSLEngineResult handshakeWrap(boolean doWrite) throws IOException {
         //this should never be called with a network buffer that contains data
         //so we can clear it here.
-        netOutBuffer.clear();
+        ((Buffer)netOutBuffer).clear();
         //perform the wrap
         getBufHandler().configureWriteBufferForRead();
         SSLEngineResult result = sslEngine.wrap(getBufHandler().getWriteBuffer(), netOutBuffer);
         //prepare the results to be written
-        netOutBuffer.flip();
+        ((Buffer)netOutBuffer).flip();
         //set the status
         handshakeStatus = result.getHandshakeStatus();
         //optimization, if we do have a writable channel, write it now
@@ -479,7 +480,7 @@ public class SecureNioChannel extends Ni
 
         if (netInBuffer.position() == netInBuffer.limit()) {
             //clear the buffer if we have emptied it out on data
-            netInBuffer.clear();
+            ((Buffer)netInBuffer).clear();
         }
         if (doread)  {
             //if we have data to read, read it
@@ -493,7 +494,7 @@ public class SecureNioChannel extends Ni
         //loop while we can perform pure SSLEngine data
         do {
             //prepare the buffer with the incoming data
-            netInBuffer.flip();
+            ((Buffer)netInBuffer).flip();
             //call unwrap
             getBufHandler().configureReadBufferForWrite();
             result = sslEngine.unwrap(netInBuffer, getBufHandler().getReadBuffer());
@@ -537,7 +538,7 @@ public class SecureNioChannel extends Ni
             throw new IOException(sm.getString("channel.nio.ssl.remainingDataDuringClose"));
         }
         //prep the buffer for the close message
-        netOutBuffer.clear();
+        ((Buffer)netOutBuffer).clear();
         //perform the close, since we called sslEngine.closeOutbound
         SSLEngineResult handshake = sslEngine.wrap(getEmptyBuf(), netOutBuffer);
         //we should be in a close state
@@ -545,7 +546,7 @@ public class SecureNioChannel extends Ni
             throw new IOException(sm.getString("channel.nio.ssl.invalidCloseState"));
         }
         //prepare the buffer for writing
-        netOutBuffer.flip();
+        ((Buffer)netOutBuffer).flip();
         //if there is data to be written
         flush(netOutBuffer);
 
@@ -612,7 +613,7 @@ public class SecureNioChannel extends Ni
         SSLEngineResult unwrap;
         do {
             //prepare the buffer
-            netInBuffer.flip();
+            ((Buffer)netInBuffer).flip();
             //unwrap the data
             unwrap = sslEngine.unwrap(netInBuffer, dst);
             //compact the buffer
@@ -689,7 +690,7 @@ public class SecureNioChannel extends Ni
                 overflowState = OverflowState.DONE;
             }
             //prepare the buffer
-            netInBuffer.flip();
+            ((Buffer)netInBuffer).flip();
             //unwrap the data
             unwrap = sslEngine.unwrap(netInBuffer, dsts, offset, length);
             //compact the buffer
@@ -797,12 +798,12 @@ public class SecureNioChannel extends Ni
             }
 
             // The data buffer is empty, we can reuse the entire buffer.
-            netOutBuffer.clear();
+            ((Buffer)netOutBuffer).clear();
 
             SSLEngineResult result = sslEngine.wrap(src, netOutBuffer);
             // The number of bytes written
             int written = result.bytesConsumed();
-            netOutBuffer.flip();
+            ((Buffer)netOutBuffer).flip();
 
             if (result.getStatus() == Status.OK) {
                 if (result.getHandshakeStatus() == HandshakeStatus.NEED_TASK) {
@@ -834,12 +835,12 @@ public class SecureNioChannel extends Ni
         }
 
         // The data buffer is empty, we can reuse the entire buffer.
-        netOutBuffer.clear();
+        ((Buffer)netOutBuffer).clear();
 
         SSLEngineResult result = sslEngine.wrap(srcs, offset, length, netOutBuffer);
         // The number of bytes written
         int written = result.bytesConsumed();
-        netOutBuffer.flip();
+        ((Buffer)netOutBuffer).flip();
 
         if (result.getStatus() == Status.OK) {
             if (result.getHandshakeStatus() == HandshakeStatus.NEED_TASK) tasks();
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/SocketBufferHandler.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/SocketBufferHandler.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/SocketBufferHandler.java
@@ -17,6 +17,7 @@
 package org.apache.tomcat.util.net;
 
 import java.nio.BufferOverflowException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 
 import org.apache.tomcat.util.buf.ByteBufferUtils;
@@ -67,13 +68,13 @@ public class SocketBufferHandler {
                 // Switching to write
                 int remaining = readBuffer.remaining();
                 if (remaining == 0) {
-                    readBuffer.clear();
+                    ((Buffer)readBuffer).clear();
                 } else {
                     readBuffer.compact();
                 }
             } else {
                 // Switching to read
-                readBuffer.flip();
+                ((Buffer)readBuffer).flip();
             }
             this.readBufferConfiguredForWrite = readBufferConFiguredForWrite;
         }
@@ -160,15 +161,15 @@ public class SocketBufferHandler {
                 // Switching to write
                 int remaining = writeBuffer.remaining();
                 if (remaining == 0) {
-                    writeBuffer.clear();
+                    ((Buffer)writeBuffer).clear();
                 } else {
                     writeBuffer.compact();
-                    writeBuffer.position(remaining);
-                    writeBuffer.limit(writeBuffer.capacity());
+                    ((Buffer)writeBuffer).position(remaining);
+                    ((Buffer)writeBuffer).limit(writeBuffer.capacity());
                 }
             } else {
                 // Switching to read
-                writeBuffer.flip();
+                ((Buffer)writeBuffer).flip();
             }
             this.writeBufferConfiguredForWrite = writeBufferConfiguredForWrite;
         }
@@ -199,9 +200,9 @@ public class SocketBufferHandler {
 
 
     public void reset() {
-        readBuffer.clear();
+        ((Buffer)readBuffer).clear();
         readBufferConfiguredForWrite = true;
-        writeBuffer.clear();
+        ((Buffer)writeBuffer).clear();
         writeBufferConfiguredForWrite = true;
     }
 
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/SocketWrapperBase.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/SocketWrapperBase.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/SocketWrapperBase.java
@@ -19,6 +19,7 @@ package org.apache.tomcat.util.net;
 import java.io.EOFException;
 import java.io.IOException;
 import java.net.SocketTimeoutException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.CompletionHandler;
 import java.nio.channels.InterruptedByTimeoutException;
@@ -1467,9 +1468,9 @@ public abstract class SocketWrapperBase<
         int max = Math.min(from.remaining(), to.remaining());
         if (max > 0) {
             int fromLimit = from.limit();
-            from.limit(from.position() + max);
+            ((Buffer)from).limit(from.position() + max);
             to.put(from);
-            from.limit(fromLimit);
+            ((Buffer)from).limit(fromLimit);
         }
         return max;
     }
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/TLSClientHelloExtractor.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/TLSClientHelloExtractor.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/TLSClientHelloExtractor.java
@@ -17,6 +17,7 @@
 package org.apache.tomcat.util.net;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.BufferUnderflowException;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
@@ -76,7 +77,7 @@ public class TLSClientHelloExtractor {
         String sniValue = null;
         try {
             // Switch to read mode.
-            netInBuffer.flip();
+            ((Buffer)netInBuffer).flip();
 
             // A complete TLS record header is required before we can figure out
             // how many bytes there are in the record.
@@ -164,8 +165,8 @@ public class TLSClientHelloExtractor {
             this.clientRequestedApplicationProtocols = clientRequestedApplicationProtocols;
             this.sniValue = sniValue;
             // Whatever happens, return the buffer to its original state
-            netInBuffer.limit(limit);
-            netInBuffer.position(pos);
+            ((Buffer)netInBuffer).limit(limit);
+            ((Buffer)netInBuffer).position(pos);
         }
     }
 
@@ -215,7 +216,7 @@ public class TLSClientHelloExtractor {
 
     private static boolean isAvailable(ByteBuffer bb, int size) {
         if (bb.remaining() < size) {
-            bb.position(bb.limit());
+            ((Buffer)bb).position(bb.limit());
             return false;
         }
         return true;
@@ -243,7 +244,7 @@ public class TLSClientHelloExtractor {
         //       the buffer contains a correctly formatted HTTP request line.
         //       The method, target and protocol are not validated.
         byte chr = 0;
-        bb.position(0);
+        ((Buffer)bb).position(0);
 
         // Skip blank lines
         do {
@@ -324,7 +325,7 @@ public class TLSClientHelloExtractor {
 
 
     private static void skipBytes(ByteBuffer bb, int size) {
-        bb.position(bb.position() + size);
+        ((Buffer)bb).position(bb.position() + size);
     }
 
 
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/WriteBuffer.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/net/WriteBuffer.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/net/WriteBuffer.java
@@ -17,6 +17,7 @@
 package org.apache.tomcat.util.net;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.util.ArrayList;
 import java.util.Iterator;
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/AsyncChannelWrapperSecure.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/websocket/AsyncChannelWrapperSecure.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/websocket/AsyncChannelWrapperSecure.java
@@ -18,6 +18,7 @@ package org.apache.tomcat.websocket;
 
 import java.io.EOFException;
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.AsynchronousSocketChannel;
 import java.nio.channels.CompletionHandler;
@@ -189,7 +190,7 @@ public class AsyncChannelWrapperSecure i
                 for (int i = offset; i < offset + length; i++) {
                     ByteBuffer src = srcs[i];
                     while (src.hasRemaining()) {
-                        socketWriteBuffer.clear();
+                        ((Buffer)socketWriteBuffer).clear();
 
                         // Encrypt the data
                         SSLEngineResult r = sslEngine.wrap(src, socketWriteBuffer);
@@ -215,7 +216,7 @@ public class AsyncChannelWrapperSecure i
                             }
                         }
 
-                        socketWriteBuffer.flip();
+                        ((Buffer)socketWriteBuffer).flip();
 
                         // Do the write
                         int toWrite = r.bytesProduced();
@@ -272,7 +273,7 @@ public class AsyncChannelWrapperSecure i
                         }
                     }
 
-                    socketReadBuffer.flip();
+                    ((Buffer)socketReadBuffer).flip();
 
                     if (socketReadBuffer.hasRemaining()) {
                         // Decrypt the data in the buffer
@@ -358,7 +359,7 @@ public class AsyncChannelWrapperSecure i
             try {
                 sslEngine.beginHandshake();
                 // So the first compact does the right thing
-                socketReadBuffer.position(socketReadBuffer.limit());
+                ((Buffer)socketReadBuffer).position(socketReadBuffer.limit());
 
                 handshakeStatus = sslEngine.getHandshakeStatus();
                 resultStatus = Status.OK;
@@ -368,11 +369,11 @@ public class AsyncChannelWrapperSecure i
                 while(handshaking) {
                     switch (handshakeStatus) {
                         case NEED_WRAP: {
-                            socketWriteBuffer.clear();
+                            ((Buffer)socketWriteBuffer).clear();
                             SSLEngineResult r =
                                     sslEngine.wrap(DUMMY, socketWriteBuffer);
                             checkResult(r, true);
-                            socketWriteBuffer.flip();
+                            ((Buffer)socketWriteBuffer).flip();
                             Future<Integer> fWrite =
                                     socketChannel.write(socketWriteBuffer);
                             fWrite.get();
@@ -386,7 +387,7 @@ public class AsyncChannelWrapperSecure i
                                         socketChannel.read(socketReadBuffer);
                                 fRead.get();
                             }
-                            socketReadBuffer.flip();
+                            ((Buffer)socketReadBuffer).flip();
                             SSLEngineResult r =
                                     sslEngine.unwrap(socketReadBuffer, DUMMY);
                             checkResult(r, false);
